#include "STC32F.H"
#include "main.h"
#include "ppu.h"
#include "keypress.h"

extern u8 hbenable, vbenable;
extern u8 ppuregcache[8];
extern u16 vramaddr, runline;
extern u8 xdata ymregcache[64];
u8 keypressed[16] = { 0 };

void P33pressed() interrupt 2 //ppureset button
{
	u8 ii = 0;
	hbenable = 0;
	vbenable = 0;
	P5 = (P5 & ~(0x0F)) | 0x10 | ((0x00) % 0x0F);
	drawstartupimage();
	writeppu(0, 0xC8);
	writeppu(1, 0x1E);
	setscroll(0, 0);
	for (ii = 0;ii < 64;ii++) {
		ymregcache[ii] = 0;
	}
	resetym();
	vramaddr = 0;
	vbenable = 1;
	hbenable = 1;
}

int keyscan() {
	u8 i = 0, k = 0, j = 0;

	//read NES controller
	CTRDAT = 1;
	CTRCLK = 0;
	CTRLAT = 1;
	for (k = 0; k < waitym12; k++) { NOP40(); };
	CTRLAT = 0;
	for (i = 0; i < 8; i++) {
		keypressed[8 + i] = (!CTRDAT) ? ((keypressed[8 + i] == 255) ? 255 : (keypressed[8 + i] + 1)) : 0;
		j += !CTRDAT;
		CTRCLK = 1;
		NOP40();
		CTRCLK = 0;
		NOP40();
	}

	//read on board button
	keypressed[0] = (!btn2) ? ((keypressed[0] == 255) ? 255 : (keypressed[0] + 1)) : 0;
	keypressed[1] = (!btn3) ? ((keypressed[1] == 255) ? 255 : (keypressed[1] + 1)) : 0;
	keypressed[2] = (!btn4) ? ((keypressed[2] == 255) ? 255 : (keypressed[2] + 1)) : 0;

	if (keypressed[0] == 1) { //bg tile page
		keypressed[3]++;
		j++;
		keypressed[3] %= 4;
	}
	if (keypressed[1] == 1) { //statusbar
		keypressed[4]++;
		j++;
		keypressed[4] %= 2;
	}
	if (keypressed[2] == 1) { //bg window
		keypressed[5]++;
		j++;
		keypressed[5] %= 4;
	}

	return j;//how many keys pressed in one frame
}