#include "STC32F.H"
#include "main.h"
#include "stc32_stc8_usb.h"
#include "setup.h"

char* USER_DEVICEDESC = NULL;
char* USER_PRODUCTDESC = NULL;
char* USER_STCISPCMD = "@STCISP#";

void ICacheOn(void)
{
	bit fEA;

	if (WTST > 0)
	{
		fEA = EA;
		EA = 0;
		_nop_();
		_nop_();
		TA = 0xaa;

		TA = 0x55;

		ICHECR = 0x01;

		_nop_();
		_nop_();
		EA = fEA;
	}
}

void ICacheOff(void)
{
	bit fEA;

	fEA = EA;
	EA = 0;
	_nop_();
	_nop_();
	TA = 0xaa;

	TA = 0x55;

	ICHECR = 0x00;

	_nop_();
	_nop_();
	EA = fEA;
}

int portsetting() {
	P0M1 = 0x00;   P0M0 = 0x00;
	P1M1 = 0xf8;   P1M0 = 0x38;
	P2M1 = 0x00;   P2M0 = 0x00;
	P3M1 = 0x00;   P3M0 = 0x00;
	P4M1 = 0x00;   P4M0 = 0x00;
	P5M1 = 0x10;   P5M0 = 0x10;
	P6M1 = 0x00;   P6M0 = 0x00;
	P7M1 = 0x00;   P7M0 = 0x00;
	return 0;
}

int usbsetting() {
	IRC48MCR = 0x80;
	while (!(IRC48MCR & 1))
	{
		NOP1();
	}
	PUSBH = 0;
	PUSB = 1;
	usb_init();
	return 0;
}

int clocksetting() {
	//XOSCCR = 0x80;
	//CLKDIV = 0x00;
	//CLKSEL = 0x01;
	//WTST=1;
	//NOP40();
	return 0;
}

int stcsetup() {
	EAXSFR();
	portsetting();
	ICacheOn();
	clocksetting();
	usbsetting();
	return 0;
}