#include "STC32F.H"
#include "main.h"
#include "ppu.h"
#include "timing.h"

u8 hbenable = 0, vbenable = 0, stable = 0;
u16 lctset = lctinit, linecount = 0, line = 0, tick = 0, runline = 0;
u32 frame = 0, fosc = 0;

int lctsetup(void)
{
	TMOD = 0x03;
	T0x12 = 1;

	TL0 = (u8)(lctset);
	TH0 = (u8)(lctset >> 8);

	return 0;
}

int intsetup(void) {
	hbenable = 0;
	vbenable = 0;
	PX0H = 1;
	PX0 = 1;
	writeppu(0, 0xC8);
	EA = 0;
	EX0 = 1;
	lctsetup();
	while (PPUINT != 0)
	{
		NOP1();
	}
	TR0 = 1;
	IT0 = 1;
	ET0 = 1;
	EA = 1;
	while (stable == 0)
	{
		NOP1();
	}
	while (frame < 70)//Wait for the TV to identify the signal
	{
		NOP1();
	}
	frame = 0;
	vbenable = 1;
	hbenable = 1;
	IT1 = 1; //enable btn1 interrupt
	EX1 = 1; //enable btn1 interrupt
	return 0;
}


void onlct(void) interrupt 1  //int line timer
{
	linecount++;
	if (hbenable == 1 && vbenable == 1) {
		hbenable = 0;
		hblank(frame, line = (linecount / linemult), tick = (linecount % linemult));
		hbenable = 1;
	}
}

void ppuint(void) interrupt 0 //ppu int
{
	TR0 = 0;
	if (linecount == totalline) {
		stable = 1;
	}
	else
	{
		stable = 0;
		linecount > totalline ? lctset-- : lctset++;
	}
	TL0 = (u8)(lctset);
	TH0 = (u8)(lctset >> 8);
	linecount = 0;
	frame++;
	TR0 = 1;
	fosc = (65536UL - lctset) * 26602 * linemult / (5 * dots);//calculate actual frequency of IRC
	if (vbenable == 1) {
		hbenable = 0;
		vbenable = 0;
		vblank(frame);
		vbenable = 1;
		hbenable = 1;
	}
}