#include "STC32F.H"
#include "main.h"
#include "ppu.h"
#include "timing.h"
#include "ym2413.h"
u8 xdata ymregcache[64];
int setym(u8 regaddr, u8 regdata) {
	u8 i = 0;
	deviceselect(1);

	DATA = regaddr;
	ADDR = 0;
	NOP15();
	CS = 0;
	i = waitym12;while (i)i--;
	CS = 1;
	i = waitym12;while (i)i--;

	DATA = regdata;
	ADDR = 1;
	NOP15();
	CS = 0;
	i = waitym12 * 7;while (i)i--;
	CS = 1;
	i = waitym12;while (i)i--;

	ymregcache[regaddr] = regdata;
	if (regaddr == 0x0e) {
		ymregcache[0x39] = regdata ^ ymregcache[0x0F];
		ymregcache[0x39] &= regdata;
		for (i = 0;i < 5;i++) {
			ymregcache[0x19 + i] = (ymregcache[0x39] % 2) ? 255 : ymregcache[0x19 + i];
			ymregcache[0x39] = ymregcache[0x39] >> 1;
		}
		ymregcache[0x0F] = regdata;
	}
	return 0;
}

int resetym() {
	u8 i = 0;
	deviceselect(1);
	CS = 0;
	RST = 0;
	i = waitym12 * 7;while (i)i--;
	RST = 1;
	CS = 1;
	i = waitym12 * 7;while (i)i--;

	return 0;
}

int vgminterpreter(u8* vgmdata, u32* point, u32* lppoint, long* wait, u8 isbuffer) {
	u32 pointt = *point;
	u8 dd = 0, aa = 0, op = isbuffer ? *(vgmdata + (pointt) % vgmbuffersize) : *(vgmdata + pointt), j = 0;
	u16 i = 0;
	P52 = !P52;
	if (op >> 4 == 7) {
		i = (op % 0x10) + 1;
		(*wait) += i; (pointt)++;
		while (i) { i--;j = 8;while (j) { j--;NOP40(); } };//Delay compensation set for some VGMs
	}
	else
	{
		switch (op) {
		case 0x51: {
			if (*wait <= 0) {
				aa = *(vgmdata + (++pointt) % (isbuffer ? vgmbuffersize : 0xFFFFFFFF));
				dd = *(vgmdata + (++pointt) % (isbuffer ? vgmbuffersize : 0xFFFFFFFF));
				setym(aa, dd);
				pointt++;
			}
			else {
				P52 = 0;
				return 4;
			}
		}break;
		case 0x61: {
			aa = *(vgmdata + (++pointt) % (isbuffer ? vgmbuffersize : 0xFFFFFFFF));
			dd = *(vgmdata + (++pointt) % (isbuffer ? vgmbuffersize : 0xFFFFFFFF));
			(*wait) += ((dd << 8) + aa);
			pointt++;
			i = ((dd << 8) + aa);
			if (i > 882)i = 0;
			while (i) { i--;j = 8;while (j) { j--;NOP40(); } };//Delay compensation set for some VGMs
		}break;
		case 0x62: { (*wait) += 735; pointt++; }break;
		case 0x63: { (*wait) += 882; pointt++; }break;
		case 0x66: { if (*wait <= 0 && isbuffer == 0) { pointt = *lppoint; } else { if (isbuffer == 0) { return 4; }pointt++; } }break;
		case 0xa0: { pointt += 3; }break;//bypass ay8910 commands
		default: { pointt++; }break;
		}
	}
	*point = pointt;
	return 0;
}